VERSION 5.00
Begin VB.Form frmPredicateQuantified 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Quantified Predicate"
   ClientHeight    =   4785
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4605
   Icon            =   "PredicateQuantified.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4785
   ScaleWidth      =   4605
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdRemove 
      Caption         =   "&Remove"
      Height          =   375
      Left            =   3360
      TabIndex        =   18
      Top             =   4260
      Width           =   1200
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "&Add"
      Height          =   375
      Left            =   3360
      TabIndex        =   17
      Top             =   3780
      Width           =   1200
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   15
      Top             =   150
      Width           =   1200
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   16
      Top             =   570
      Width           =   1200
   End
   Begin VB.Frame fraPredicate 
      Caption         =   "Quantified Predicate"
      Height          =   4575
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   3150
      Begin VB.CheckBox chkIncludeEmptyString 
         Caption         =   "List includes empty string"
         Height          =   225
         Left            =   120
         TabIndex        =   19
         Top             =   4080
         Width           =   2835
      End
      Begin VB.ListBox lstExpressionList 
         Height          =   840
         ItemData        =   "PredicateQuantified.frx":030A
         Left            =   90
         List            =   "PredicateQuantified.frx":030C
         TabIndex        =   9
         Top             =   3000
         Width           =   2955
      End
      Begin VB.TextBox txtIn 
         Height          =   315
         Left            =   90
         TabIndex        =   7
         Top             =   2340
         Width           =   2955
      End
      Begin VB.Frame fraQuantifier 
         Caption         =   "Quantifier"
         Height          =   570
         Left            =   90
         TabIndex        =   5
         Top             =   1410
         Width           =   2970
         Begin VB.OptionButton optQuantifier 
            Caption         =   "Some resp. Any"
            Height          =   195
            Index           =   1
            Left            =   1080
            TabIndex        =   14
            Top             =   270
            Width           =   1785
         End
         Begin VB.OptionButton optQuantifier 
            Caption         =   "All"
            Height          =   195
            Index           =   0
            Left            =   120
            TabIndex        =   10
            Top             =   270
            Width           =   735
         End
      End
      Begin VB.Frame Frame1 
         Caption         =   "Compare with"
         Height          =   1035
         Left            =   90
         TabIndex        =   2
         Top             =   270
         Width           =   2970
         Begin VB.OptionButton optComp 
            Caption         =   "<"
            Height          =   225
            Index           =   0
            Left            =   90
            TabIndex        =   1
            Top             =   270
            Width           =   705
         End
         Begin VB.OptionButton optComp 
            Caption         =   "="
            Height          =   225
            Index           =   2
            Left            =   90
            TabIndex        =   3
            Top             =   510
            Width           =   705
         End
         Begin VB.OptionButton optComp 
            Caption         =   "<="
            Height          =   225
            Index           =   4
            Left            =   90
            TabIndex        =   4
            Top             =   750
            Width           =   705
         End
         Begin VB.OptionButton optComp 
            Caption         =   ">"
            Height          =   225
            Index           =   1
            Left            =   990
            TabIndex        =   11
            Top             =   270
            Width           =   705
         End
         Begin VB.OptionButton optComp 
            Caption         =   "<>"
            Height          =   225
            Index           =   3
            Left            =   990
            TabIndex        =   12
            Top             =   510
            Width           =   705
         End
         Begin VB.OptionButton optComp 
            Caption         =   ">="
            Height          =   225
            Index           =   5
            Left            =   990
            TabIndex        =   13
            Top             =   750
            Width           =   705
         End
      End
      Begin VB.Label lblExpression 
         Caption         =   "Expression"
         Height          =   255
         Left            =   90
         TabIndex        =   6
         Top             =   2070
         Width           =   2970
      End
      Begin VB.Label lblExpressionList 
         Caption         =   "Expression List"
         Height          =   255
         Left            =   90
         TabIndex        =   8
         Top             =   2760
         Width           =   2925
      End
   End
End
Attribute VB_Name = "frmPredicateQuantified"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Form:       frmPredicateQuantified - Form for In Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmPredicateQuantified"

Private Const CompareSmaller = 0
Private Const CompareGreater = 1
Private Const CompareEqual = 2
Private Const CompareUnequal = 3
Private Const CompareEqualSmaller = 4
Private Const CompareEqualGreater = 5

Private Const QuantifyAll = 0
Private Const QuantifySome = 1

'local copy of properties
Dim m_oPredicateQuantified        As SQLStudioMan.predicateQuantified
Dim m_oColDef                     As SQLStudioDBLayer.Column

'local variables
Dim m_oPredicateQuantifiedCopy    As New SQLStudioMan.predicateQuantified
Private Sub copyPredicate(DestPredicate As SQLStudioMan.predicateQuantified, SrcPredicate As SQLStudioMan.predicateQuantified)
    On Error GoTo errCopyPredicate

    Const FUNCTION_NAME = "copyPredicate"
    
    Dim Value   As Variant
    
    '  Copy predicate
    DestPredicate.arrange = SrcPredicate.arrange
    DestPredicate.comparison = SrcPredicate.comparison
    DestPredicate.Quantifier = SrcPredicate.Quantifier
    DestPredicate.includeEmptyString = SrcPredicate.includeEmptyString
    
    For Each Value In SrcPredicate.ValueList
        DestPredicate.AddValue Value
    Next
    
    Exit Sub
    
errCopyPredicate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Property Set predicateQuantified(NewPredicateQuantified As SQLStudioMan.predicateQuantified)
    On Error GoTo errP_SET_PredicateQuantified

    Const FUNCTION_NAME = "P_SET PredicateQuantified"
    
    Dim Value   As Variant
    
    If NewPredicateQuantified Is Nothing Then Exit Property
    
    Set m_oPredicateQuantified = NewPredicateQuantified
    
    '  Copy predicate
    copyPredicate m_oPredicateQuantifiedCopy, NewPredicateQuantified
    
    
    
    Select Case m_oPredicateQuantified.comparison
        Case SQLStudioMan.PredicateCompareSmaller:
            optComp(CompareSmaller).Value = True
        Case SQLStudioMan.PredicateCompareGreater:
            optComp(CompareGreater).Value = True
        Case SQLStudioMan.PredicateCompareEqual:
            optComp(CompareEqual).Value = True
        Case SQLStudioMan.PredicateCompareUnequal:
            optComp(CompareUnequal).Value = True
        Case SQLStudioMan.PredicateCompareEqualSmaller:
            optComp(CompareEqualSmaller).Value = True
        Case SQLStudioMan.PredicateCompareEqualGreater:
            optComp(CompareEqualGreater).Value = True
    End Select
    
    Select Case m_oPredicateQuantified.Quantifier
        Case SQLStudioMan.PredicateQuantifierAll:
            optQuantifier(QuantifyAll).Value = True
        Case SQLStudioMan.PredicateQuantifierSome:
            optQuantifier(QuantifySome).Value = True
    End Select
    
    For Each Value In m_oPredicateQuantified.ValueList
        lstExpressionList.AddItem Value
    Next
    
    '  Is expression list empty?
    If lstExpressionList.ListCount = 0 Then
        cmdRemove.Enabled = False
    Else
        cmdRemove.Enabled = True
    End If
    
    If m_oPredicateQuantified.includeEmptyString Then
        chkIncludeEmptyString = vbChecked
    Else
        chkIncludeEmptyString = vbUnchecked
    End If
    
    Exit Property
    
errP_SET_PredicateQuantified:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Set columnDefinition(NewColumnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errP_SET_ColumnDefinition

    Const FUNCTION_NAME = "P_SET ColumnDefinition"
    
    Set m_oColDef = NewColumnDefinition
    
    If m_oColDef.sapdbColType = sapdbColTypeChar Or _
       m_oColDef.sapdbColType = sapdbColTypeVarChar _
    Then
        chkIncludeEmptyString.Enabled = True
    Else
        chkIncludeEmptyString.Enabled = False
    End If
    
    Exit Property
    
errP_SET_ColumnDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateQuantified() As SQLStudioMan.predicateQuantified
    On Error GoTo errP_Get_PredicateQuantified

    Const FUNCTION_NAME = "P_Get predicateQuantified"
    
    Set predicateQuantified = m_oPredicateQuantified
    
    Exit Property
    
errP_Get_PredicateQuantified:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub cmdAdd_Click()
    On Error GoTo errCmdAdd_Click

    Const FUNCTION_NAME = "cmdAdd_Click"
    
    '  Is there an expression?
    If Len(txtIn.text) > 0 Then
        'Add expression to IN list
        If m_oPredicateQuantified.AddValue(txtIn.text) Then
            'Add expression to list
            lstExpressionList.AddItem txtIn.text
            
            '  Enable remove button
            cmdRemove.Enabled = True
            
            'set focus to textbox
            txtIn.SelStart = 0
            txtIn.SelLength = Len(txtIn.text)
            txtIn.SetFocus
        End If
    End If
    
    If lstExpressionList.ListCount = 0 Then
        cmdRemove.Enabled = False
        cmdOk.Enabled = False
    Else
        cmdRemove.Enabled = True
        cmdOk.Enabled = True
    End If
    
    Exit Sub
    
errCmdAdd_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    'set old predicate values
    copyPredicate m_oPredicateQuantified, m_oPredicateQuantifiedCopy
    
    Err.Number = cdlCancel
    
    '  Unload form
    Unload Me
    
    Exit Sub
    
errCmdCancel_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
    
    Const FUNCTION_NAME = "cmdOk_Click"
    
     If m_oPredicateQuantified.ValueList.Count > 0 Or _
        ((m_oColDef.sapdbColType = sapdbColTypeChar Or _
          m_oColDef.sapdbColType = sapdbColTypeVarChar) _
            And _
         m_oPredicateQuantified.includeEmptyString) _
     Then
        
        Unload Me               '  Unload form
        Err.Number = 0
    Else
        txtIn.SetFocus
        Exit Sub
    End If
    
    Exit Sub
    
errCmdOk_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdRemove_Click()
    On Error GoTo errCmdRemove_Click

    Const FUNCTION_NAME = "cmdRemove_Click"
    
    Dim i   As Long
    
    'scan list
    i = 0
    While i < lstExpressionList.ListCount
        '  Is item selected?
        If lstExpressionList.Selected(i) Then
            '  Remove item from IN list
            m_oPredicateQuantified.RemoveValue lstExpressionList.list(i)
            
            '  Remove item from list
            lstExpressionList.RemoveItem i
        Else
            '  Increment index
            i = i + 1
        End If
    Wend
    
    '  Is expression list empty?
    If lstExpressionList.ListCount = 0 And Not (m_oColDef.sapdbColType = sapdbColTypeChar Or m_oColDef.sapdbColType = sapdbColTypeVarChar) Then
        cmdRemove.Enabled = False
        cmdOk.Enabled = False
    Else
        cmdRemove.Enabled = True
        cmdOk.Enabled = True
    End If
            
    'set focus to textbox
    txtIn.SelStart = 0
    txtIn.SelLength = Len(txtIn.text)
    txtIn.SetFocus
    
    Exit Sub
    
errCmdRemove_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


Private Sub optComp_Click(Index As Integer)
    On Error GoTo errOptComp_Click

    Const FUNCTION_NAME = "optComp_Click"
    
    Select Case Index
        Case CompareSmaller:
            m_oPredicateQuantified.comparison = SQLStudioMan.PredicateCompareSmaller
        Case SQLStudioMan.PredicateCompareGreater:
            m_oPredicateQuantified.comparison = SQLStudioMan.PredicateCompareGreater
        Case SQLStudioMan.PredicateCompareEqual:
            m_oPredicateQuantified.comparison = SQLStudioMan.PredicateCompareEqual
        Case SQLStudioMan.PredicateCompareUnequal:
            m_oPredicateQuantified.comparison = SQLStudioMan.PredicateCompareUnequal
        Case SQLStudioMan.PredicateCompareEqualSmaller:
            m_oPredicateQuantified.comparison = SQLStudioMan.PredicateCompareEqualSmaller
        Case SQLStudioMan.PredicateCompareEqualGreater:
            m_oPredicateQuantified.comparison = SQLStudioMan.PredicateCompareEqualGreater
    End Select
    
    Exit Sub
    
errOptComp_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


Private Sub optQuantifier_Click(Index As Integer)
    On Error GoTo errOptQuantifier_Click

    Const FUNCTION_NAME = "optQuantifier_Click"
    
    Select Case Index
        Case QuantifyAll:
            m_oPredicateQuantified.Quantifier = SQLStudioMan.PredicateQuantifierAll
        Case QuantifySome:
            m_oPredicateQuantified.Quantifier = SQLStudioMan.PredicateQuantifierSome
    End Select
    
    Exit Sub
    
errOptQuantifier_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtIn_Change()
    On Error GoTo errTxtIn_Change

    Const FUNCTION_NAME = "txtIn_Change"
    
    If txtIn.text <> "" Then
        cmdAdd.Enabled = True
    Else
        cmdAdd.Enabled = False
    End If
    
    Exit Sub
    
errTxtIn_Change:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"

    Err.Number = cdlCancel
    
    Exit Sub
    
errForm_Unload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkIncludeEmptyString_Click()
    On Error GoTo errChkIncludeEmptyString_Click

    Const FUNCTION_NAME = "chkIncludeEmptyString_Click"
    
    If chkIncludeEmptyString.Value = vbChecked Then
    
        m_oPredicateQuantified.includeEmptyString = True
    Else
        m_oPredicateQuantified.includeEmptyString = False
    End If
    
    Exit Sub
    
errChkIncludeEmptyString_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
